hdu3613 Best Reward【Manacher】

Best Reward

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 4345    Accepted Submission(s): 1791

Problem Description

After an uphill battle, General Li won a great victory. Now the head of state decide to reward him with honor and treasures for his great exploit.

One of these treasures is a necklace made up of 26 different kinds of gemstones, and the length of the necklace is n. (That is to say: n gemstones are stringed together to constitute this necklace, and each of these gemstones belongs to only one of the 26 kinds.)

In accordance with the classical view, a necklace is valuable if and only if it is a palindrome - the necklace looks the same in either direction. However, the necklace we mentioned above may not a palindrome at the beginning. So the head of state decide to cut the necklace into two part, and then give both of them to General Li.

All gemstones of the same kind has the same value (may be positive or negative because of their quality - some kinds are beautiful while some others may looks just like normal stones). A necklace that is palindrom has value equal to the sum of its gemstones‘ value. while a necklace that is not palindrom has value zero.

Now the problem is: how to cut the given necklace so that the sum of the two necklaces‘s value is greatest. Output this value.

Input

The first line of input is a single integer T (1 ≤ T ≤ 10) - the number of test cases. The description of these test cases follows.

For each test case, the first line is 26 integers: v1, v2, ..., v26 (-100 ≤ vi ≤ 100, 1 ≤ i ≤ 26), represent the value of gemstones of each kind.

The second line of each test case is a string made up of charactor ‘a‘ to ‘z‘. representing the necklace. Different charactor representing different kinds of gemstones, and the value of ‘a‘ is v1, the value of ‘b‘ is v2, ..., and so on. The length of the string is no more than 500000.

Output

Output a single Integer: the maximum value General Li can get from the necklace.

Sample Input

2
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
aba
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
acacac

Sample Output

1
6

Source

2010 ACM-ICPC Multi-University Training Contest(18)——Host by TJU

Recommend

lcy

题意:

给定一个字符串,以及每个字母拥有的价值。现在要把这个字符串切成两半,如果子串是回文,那么就可以加上这个子串的字符价值之和,如果不是回文这个子串的价值就是0.

现在要求两个子串相加的最大价值。

思路:

用Manacher我们可以处理出,以某个节点$i$为中心时的回文串长度, 即$p[i]-1$。

如果暴力枚举分割点,如果子串的中心的$p[i] - 1$正好是子串的长度,那么说明这个子串是一个回文串。

这里由于我们要算每个字符的价值之和,可以预处理前缀和。

对于偶数长度的串和奇数长度的串分别求对应的价值。

 1 //#include<bits/stdc++>
 2 #include<stdio.h>
 3 #include<iostream>
 4 #include<algorithm>
 5 #include<cstring>
 6 #include<stdlib.h>
 7
 8 #define LL long long
 9 #define ull unsigned long long
10 #define inf 0x3f3f3f3f
11
12 using namespace std;
13
14 int t;
15 int val[30];
16 const int maxlen = 5e5 + 5;
17 char s[maxlen], s_new[maxlen * 2];
18 int s_val[maxlen], p[maxlen * 2];
19
20 int init()
21 {
22     int len = strlen(s + 1);
23     s_new[0] = ‘$‘;
24     s_new[1] = ‘#‘;
25     int j = 2;
26     for(int i = 1; i <= len; i++){
27         s_new[j++] = s[i];
28         s_new[j++] = ‘#‘;
29     }
30     s_new[j] = ‘\0‘;
31     return j;
32 }
33
34 void manacher()
35 {
36     int len = init();
37     int id, mx = 0;
38
39     for(int i = 1; i < len; i++){
40         if(i < mx)p[i] = min(p[2 * id - i], mx - i);
41         else p[i] = 1;
42         while(s_new[i - p[i]] == s_new[i + p[i]])p[i]++;
43         if(mx < i + p[i]){
44             id = i;
45             mx = i + p[i];
46         }
47     }
48 }
49
50 int main()
51 {
52     scanf("%d", &t);
53     while(t--){
54         memset(p, 0, sizeof(p));
55         for(int i = 0; i < 26; i++){
56             scanf("%d", &val[i]);
57         }
58         scanf("%s", s + 1);
59
60         int len = strlen(s + 1);
61         for(int i = 1; i <= len; i++){
62             s_val[i] = s_val[i - 1] + val[s[i] - ‘a‘];
63         }
64         manacher();
65 //        cout<<s_new<<endl;
66 //        for(int i = 0; i <= len * 2; i++){
67 //            cout<<p[i]<<" ";
68 //        }
69 //        cout<<endl;
70
71         int ans = 0;
72         for(int i = 1; i < len; i++){
73             int tmp = 0;
74             if(p[i + 1] - 1 == i){
75                 if(i % 2){
76                     tmp += s_val[i / 2] * 2 + val[s[(i + 1) / 2] - ‘a‘];
77                 }
78                 else{
79                     tmp += s_val[i / 2] * 2;
80                 }
81             }
82             if(p[i + len + 1] - 1 == len - i){
83                 if((len - i) % 2){
84                     tmp += (s_val[i + (len - i) / 2] - s_val[i]) * 2 + val[s[i + (len + 1- i) / 2] - ‘a‘];
85                 }
86                 else{
87                     tmp += (s_val[i + (len - i) / 2] - s_val[i]) * 2;
88                 }
89             }
90             ans = max(ans, tmp);
91         }
92         printf("%d\n", ans);
93     }
94
95 }

原文地址:https://www.cnblogs.com/wyboooo/p/10259959.html

时间: 2024-10-10 20:57:10

hdu3613 Best Reward【Manacher】的相关文章

hdu 5371 Hotaru&#39;s problem【manacher】

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=5371 题意: 给出一个长度为n的串,要求找出一条最长连续子串.这个子串要满足:1:可以平均分成三段,2:第一段和第三段相等,3:第一段和第二段回文.求最大子串的长度. 代码: #include<stdio.h> #include<iostream> #include<math.h> #include<stdlib.h> #include<ctype.h&

【manacher】HDU3068-最长回文

[题目大意] 给出一个只由小写英文字符a,b,c...y,z组成的字符串S,求S中最长回文串的长度. [manacher知识点] ①mx - i > P[j] 的时候,以S[j]为中心的回文子串包含在以S[id]为中心的回文子串中,由于 i 和 j 对称,以S[i]为中心的回文子串必然包含在以S[id]为中心的回文子串中,所以必有 P[i] = P[j]. ②当 P[j] > mx - i 的时候,以S[j]为中心的回文子串不完全包含于以S[id]为中心的回文子串中,但是基于对称性可知,下图中

关于字符串问题【Manacher】

Manacher是用来求最长回文子串的.做法很好理解,有一点贪心的感觉. 解释一下加#号字符串abbaba,abba和aba都回文子串,但是一个长度是奇数,一个是偶数,直接做还要分情况讨论.如果变成#a#b#b#a#b#a#,那#a#b#b#a#和#a#b#a# 长度都是奇数,而且开头结尾都是#号,这样比较方便. 具体的做法结合代码.注释就可以理解了 #include<cstdio> #include<cstring> #include<algorithm> using

hdu 5340 Three Palindromes 【Manacher】

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5340 题意:判断一个字符串能否分为三个回文串 解法:manacher枚举第一第三个,判断第二个. 代码: #include <stdio.h> #include <ctime> #include <math.h> #include <limits.h> #include <complex> #include <string> #inclu

LOJ6387 [THUPC2018] 绿绿与串串 【manacher】

题目分析: 比较简单,先跑一边manacher,然后对于回文部分可以碰到末尾的一定满足条件,否则向后转移. 代码: 1 #include<bits/stdc++.h> 2 using namespace std; 3 4 const int maxn = 1000020; 5 6 char str[maxn],solve[maxn<<1]; 7 int f[maxn<<1],n; 8 9 void manacher(){ 10 memset(f,0,sizeof(f))

【8.15校内测试】【队列】【manacher】

dp??不能确定转移状态.考虑用优先队列储存最优决策点,可是发现当前选择最优不能保证最后最优,在后面可以将之前用过的替换过来. 比如数据: 3 5 4 6 只储存a[i]来决策不能延展到后面的状态,因此每次选择过后把b[i]加入队列,下次选择最优时如果选择到了b[i],则表示用之前选择过的来替换到当前状态. 这里我开了两个优先队列. 1 #include<iostream> 2 #include<cstdio> 3 #include<queue> 4 #define l

2018ACM-ICPC南京区域赛M---Mediocre String Problem【exKMP】【Manacher】

这题就单独写个题解吧.想了两天了,刚刚问了一个大佬思路基本上有了. 题意: 一个串$S$,一个串$T$,在$S$中选一段子串$S[i,j]$,在$T$中选一段前缀$T[1,k]$使得$S[i,j]T[1,k]$拼起来得到的字符串是回文,并且$S$的这个串长度大于$T$的这个.问有多少这样的三元组$(i,j,k)$ 思路: 首先我们可以知道我们要找的其实就是这样三个串,$a,b,c$.其中$a$和$c$合起来是$S$中连续的一段子串,$b$在$T$中且$a$和$b$是对称的,$c$一定要是一个回文

【manacher+FFT】BZOJ3160-万径人踪灭

[题目大意] 在一个仅仅含有a,b的字符串里选取一个子序列,使得: 1.位置和字符都关于某条对称轴对称: 2.不能是连续的一段. [思路] 不连续的回文串的个数=总的回文串个数-连续回文串的个数. 后者可以用manacher在O(n)时间里面求出.求的是个数不是最长串,和之前写的几道不怎么一样,注意一下. 求总的回文串个数稍微复杂一些.我们用f[i]表示以i为对称中心,两边有多少个对称的字符.对于每个中心i我们有(2^f[i])-1种方案 答案即Σ[1<=i<=n*2+1]((2^f[i])-

【BZOJ3325】[Scoi2013]密码 Manacher

[BZOJ3325][Scoi2013]密码 Description Fish是一条生活在海里的鱼.有一天他很无聊,就到处去寻宝.他找到了位于海底深处的宫殿,但是一扇带有密码锁的大门却阻止了他的前进.通过翻阅古籍,Fish 得知了这个密码的相关信息: 1. 该密码的长度为N. 2. 密码仅含小写字母. 3. 以每一个字符为中心的最长回文串长度. 4. 以每两个相邻字符的间隙为中心的最长回文串长度. 很快Fish 发现可能有无数种满足条件的密码.经过分析,他觉得这些密码中字典序最小的一个最有可能是